#include "ttyio.h"

#define XOFF		DC1
#define XON		DC3
#define H_DLE		CAN
#define SP		0x20

/* unframed packet types */
#define H_START		'A'	/* Startup sequence                */
#define H_INIT		'B'	/* Session initialisation          */
#define H_INITACK	'C'	/* Response to HINIT packet        */
#define H_FINFO		'D'	/* File information                */
#define H_FINFOACK	'E'	/* Response to HFINFO packet       */
#define H_DATA		'F'	/* File data packet                */
#define H_DATAACK	'G'	/* File data position ACK packet   */
#define H_RPOS		'H'	/* Reposition request packet       */
#define H_EOF		'I'	/* End of file packet              */
#define H_EOFACK	'J'	/* Response to HEOF packet         */
#define H_END_S		'K'	/* End of session                  */
#define H_IDLE		'L'	/* Idle (just saying I'm alive)    */
#define H_DEVDATA	'M'	/* Data to specified device        */
#define H_DEVDACK	'N'	/* Response to HDEVDATA packet     */

/* framed packet types */
#define H_END_P		'a'	/* End of framed packet            */
#define H_BIN		'b'	/* Binary packet                   */
#define H_HEX		'c'	/* Hex encoded packet              */
#define H_ASC		'd'	/* Shifted 7-bit encoded packet    */
#define H_UUE		'e'	/* UUencoded packet                */

